---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Clock","RIGHT")
local btn = gb.Clock
btn.text              = "Clock"
--btn.font              = "Interface\\AddOns\\Glance\\fonts\\digital-7.ttf"
btn.events            = {}
btn.enabled           = true
btn.update            = true
btn.tooltip           = true
btn.click             = true
btn.timer1            = true
btn.menu              = true
btn.save.perAccount   = {["DisplayClock"] = "server"}
local spa = btn.save.perAccount


---------------------------
-- update
---------------------------
function gf.Clock.update()
	local btn  = gb.Clock
	local func = gf.Clock
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		local hour, min = GetGameTime()
		local lhour = tonumber(date("%H"))
		if spa.DisplayClock == "local" then
			btn.button:SetFormattedText("|r%s:%s %s (L)", func.GetHour(lhour), func.GetMin(min), func.GetAMPM(lhour))
		elseif spa.DisplayClock == "date" then
			btn.button:SetText(date("%m/%d/%y"))
		else
			btn.button:SetFormattedText("|r%s:%s %s (S)", func.GetHour(hour), func.GetMin(min), func.GetAMPM(hour))
		end
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Clock.tooltip()
	Glance.Debug("function","tooltip","Clock")
	local func = gf.Clock
	local tooltip = gf.Tooltip
	local hour, min = GetGameTime()
	local lhour = tonumber(date("%H"))
	tooltip.Title("Clock","GLD")
	tooltip.Double("Server Time: ", func.GetHour(hour)..":"..func.GetMin(min).." "..func.GetAMPM(hour), "WHT","GRN")
	tooltip.Double("Local Time: ", func.GetHour(lhour)..":"..func.GetMin(min).." "..func.GetAMPM(lhour), "WHT","GRN")
	tooltip.Double("Date: ", date("%m/%d/%y"), "WHT","GRN")
	tooltip.Space()
	tooltip.Line("(Click to open the calendar)","WHT")
	tooltip.Line("(Right-Click to switch display)","WHT")
end

---------------------------
-- click
---------------------------
function gf.Clock.click(self, button, down)
	Glance.Debug("function","click","Clock")
	if (button == "LeftButton") then 
		ToggleCalendar()
	end
end

---------------------------
-- menu
---------------------------
function gf.Clock.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Clock")
	local HEX = ga.colors.HEX
	level = level or 1
	if (level == 1) then
		gf.setInfo(nil,true,false,true,nil,HEX.white.."Clock Options","spacer",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Display","display",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "display" then
			local checked, func
			if spa.DisplayClock=="local" then checked = true else checked = false end
			func = function() spa.DisplayClock="local"; spa.DisplayClock="local"; gf.Clock.update() end;
			--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
			gf.setInfo(nil,false,false,false,checked,"Local Time","Local Time",level,func)
			if spa.DisplayClock=="server" then checked = true else checked = false end
			func = function() spa.DisplayClock="server"; spa.DisplayClock="server"; gf.Clock.update() end;
			gf.setInfo(nil,false,false,false,checked,"Server Time","Server Time",level,func)
			if spa.DisplayClock=="date" then checked = true else checked = false end
			func = function() spa.DisplayClock="date"; spa.DisplayClock="date"; gf.Clock.update() end;
			gf.setInfo(nil,false,false,false,checked,"Date","Date",level,func)
		end
	end
end

---------------------------
-- Clock Hour function
---------------------------
function gf.Clock.GetHour(hour)
	if hour > 12 then
		hour = hour - 12
	end
	if hour == 0 then
		hour = 12
	end
	return hour
end

---------------------------
-- Clock Hour function
---------------------------
function gf.Clock.GetMin(min)
	if min < 10 then
		return "0"..min
	end
	return min
end

---------------------------
-- Clock DST function
---------------------------
function gf.Clock.GetAMPM(hour)
	if hour < 12 then
		return "AM"
	else
		return "PM"
	end
end

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Clock")
end
