---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons

---------------------------
-- create the button
---------------------------
gf.AddButton("Professions","LEFT")
local btn = gb.Professions
btn.text              = "Professions"
btn.enabled           = true
btn.events            = {"CHAT_MSG_SKILL"}
btn.update            = true
btn.click             = true
btn.tooltip           = true
btn.menu              = true
btn.save.perCharacter = {["Profession"] = 0}
local spc = btn.save.perCharacter

---------------------------
-- variables
---------------------------
ga.Professions = {
	["75"]  = "Apprentice",
	["150"] = "Journeyman",
	["225"] = "Expert",
	["300"] = "Artisan",
	["375"] = "Master",
	["450"] = "Grand Master",
	["525"] = "Illustrious",
	["535"] = "Illustrious",
	["540"] = "Illustrious",
	["600"] = "Zen Master",
}

---------------------------
-- update
---------------------------
function gf.Professions.update(self, event, arg1)
	local btn = gb.Professions
	if btn.enabled and gv.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Professions")
		local HEX = ga.colors.HEX
		if spc.Profession ~= 0 then
			local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(spc.Profession)
			if maxSkillLevel ~= nil then 
				--btn.button:SetText("|T"..icon..":16|t "..name..": "..HEX.green..skillLevel.."/"..maxSkillLevel)
				btn.button:SetText(skillLevel.."/"..maxSkillLevel.." |T"..icon..":16|t")
			end
		else
			btn.button:SetText(HEX.red.."Professions")
		end
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function gf.Professions.tooltip()
	Glance.Debug("function","tooltip","Professions")
	local tooltip = gf.Tooltip
	local HEX = ga.colors.HEX
	tooltip.Title("Professions", "GLD")
	gf.Professions.update()
	local herb,mine = "",""
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	local Professions = {
		[1] = prof1,
		[2] = prof2,
		[3] = archaeology,
		[4] = fishing,
		[5] = cooking,
		[6] = firstAid
	}
	for i=1,6 do
		if Professions[i] ~= nil then
			local pLevel = ""
			local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(Professions[i])
			if ga.Professions[""..maxSkillLevel] ~= nil then
				pLevel = ga.Professions[""..maxSkillLevel]
			end
			tooltip.Double("|T"..icon..":0|t "..name..": "..HEX.lightblue.."("..pLevel..")", skillLevel.."/"..maxSkillLevel, "WHT","GRN")
			--tooltip.Double(name..": "..HEX.lightblue.."("..pLevel..")", skillLevel.."/"..maxSkillLevel, "WHT","GRN")
			if name=="Mining" and skillLevel < 600 then
				for i=#Glance.Data.Mining,1,-1 do
					local ore, lvl, loc = unpack(Glance.Data.Mining[i])
					if skillLevel >= lvl then mine = "You should be mining "..HEX.orange..ore.."|r in: "..HEX.yellow..loc break end
				end
			end
			if name=="Herbalism" and skillLevel < 600 then
				for i=#Glance.Data.Herbalism,1,-1 do
					local ore, lvl, loc = unpack(Glance.Data.Herbalism[i])
					if skillLevel >= lvl then herb = "You should be gathering "..HEX.orange..ore.."|r in: "..HEX.yellow..loc break end
				end
			end
		end
	end
	if mine ~= "" then
		tooltip.Space()
		tooltip.Line("Mining","GLD")
		tooltip.Wrap(mine,"WHT")
	end
	if herb ~= "" then
		tooltip.Space()
		tooltip.Line("Herbalism","GLD")
		tooltip.Wrap(herb,"WHT")
	end
	tooltip.Space()
	tooltip.Line("(Click to open the Professions tab.)","WHT")
	tooltip.Line("(Right-Click to change Profession tracking.)","WHT")
	--for i=1, GetNumTradeSkills() do 
	--	skillName, skillType, numAvailable, isExpanded, serviceType, numSkillUps = GetTradeSkillInfo(i)
	--	print(skillName)
	--end
end

---------------------------
-- click
---------------------------
function gf.Professions.click(self, button, down)
	Glance.Debug("function","click","Professions")
	if button == "LeftButton" then
		-- ToggleSpellBook("professions") -- causes permission error now..
		ToggleFrame(SpellBookFrame)
	end
end

---------------------------
-- menu
---------------------------
function gf.Professions.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Professions")
	local HEX = ga.colors.HEX
	level = level or 1
	if (level == 1) then
		gf.setInfo(nil,true,false,true,nil,HEX.white.."Professions Options","spacer",level,nil)
		gf.setInfo(nil,nil,true,true,nil,HEX.gold.."Tracking","tracking",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "tracking" then
			local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
			local Professions = {
				[1] = prof1,
				[2] = prof2,
				[3] = archaeology,
				[4] = fishing,
				[5] = cooking,
				[6] = firstAid
			}
			for i=1,6 do
				if Professions[i] ~= nil then
					local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(Professions[i])
					local checked, func
					if spc.Profession == Professions[i] then checked = true else checked = false end
					func = function() spc.Profession = Professions[i]; spc.Profession = Professions[i]; gf.Professions.update()  end;
					--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
					gf.setInfo(nil,false,false,false,checked,name,name,level,func,icon)
				end
			end
		end
	end
end


---------------------------
-- mining
---------------------------
Glance.Data.Mining = {
	{"Copper",1,"Alterac Mountains, Ashenvale, Darkshore, Desolace, Dun Morogh, Durotar, Duskwood, Elwynn Forest, Hillsbrad Foothills, Loch Modan, Mulgore, Redridge Mountains, Silverpine Forest, Stonetalon Mountains, The Barrens, Thousand Needles, Thunder Bluff, Tirisfal Glades, Westfall, Wetlands"},
	{"Tin",65,"The Barrens, Silverpine Forest, Darkshore, Ashenvale, Duskwood, Thousand Needles, Hillsbrad Foothills, Redridge Mountains, Loch Modan, Arathi Highlands, Wetlands, Stonetalon Mountains, Westfall, Alterac Mountains, Stranglethorn Vale, Desolace, Dustwallow Marsh, Feralas"},
	{"Silver",75,"Alterac Mountains, Arathi Highlands, Ashenvale, Badlands, Darkshore, Desolace, Duskwood, Dustwallow Marsh, Feralas, Hillsbad Foot hills, Loch Modan, Redridge Mountains, Searing Gorge, Silverpine Forest, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Barrens, The Hinterlands, Thousand Needles, Westfall, Wetlands"},
	{"Iron",125,"Alterac Mountains, Arathi Highlands, Ashenvale, Badlands, Desolace, Duskwood, Dustwallow Marsh, Feralas, Hillsbrad Foothills, Searing Gorge, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Hinterlands, Thousand Needles, Wetlands"},
	{"Gold",155,"Alterac Mountains, Alterac Valley, Arathi Highlands, Ashenvale, Azshara, Badlands, Blasted Lands, Burning Steppes, Desolace, Duskwood, Dustwallow Marsh, Eastern Plaguelands, Felwood, Feralas, Hillsbrad Foothills, Searing Gorge, Silithus, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Hinterlands, Thousand Needles, Un'Goro Crater, Western Plaguelands, Wetlands, Winterspring"},
	{"Mithril",175,"Alterac Mountains, Arathi Highlands, Azshara, Badlands, Blasted Lands, Burning Steppes, Desolace, Dustwallow Marsh, Eastern Plaguelands, Felwood, Feralas, Hillsbrad Foothills, Searing Gorge, Silithus, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Hinterlands, Un'Goro Crater, Western Plaguelands, Winterspring"},
	{"Truesilver",230,"Alterac Mountains, Arathi Highlands, Azshara, Badlands, Blasted Lands, Burning Steppes, Desolace, Dustwallow Marsh, Eastern Plaguelands, Felwood, Feralas, Hillsbrad Foothills, Searing Gorge, Silithus, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Hinterlands, Thousand Needles, Un'Goro Crater, Western Plaguelands, Winterspring"},
	{"Dark Iron",230,"Burning Steppes, Searing Gorge, Blackrock Depths, The Molten Core"},
	{"Small Thorium",245,"Blasted Lands, Burning Steppes, Eastern Plaguelands, Felwood, Feralas, Searing Gorge, Silithus, Tanaris, The Hinterlands, Un'Goro Crater, Western Plaguelands, Winterspring"},
	{"Rich Thorium",275,"Azshara, Burning Steppes, Eastern Plaguelands, Un'Goro Crater, Western Plaguelands, Winterspring"},
	{"Fel Iron",300,"Hellfire Peninsula, Zangarmarsh, Terokkar Forest, Nagrand, Blade's Edge Mountains, Netherstorm, Shadowmoon Valley"},
	{"Adamantite",325,"Zangarmarsh, Terokkar Forest, Nagrand, Blade's Edge Mountains, Netherstorm, Shadowmoon Valley, and Dungeons"},
	{"Rich Adamantite",350,"Terokkar Forest, Nagrand, Blade's Edge Mountains, Netherstorm, Shadowmoon Valley, and Dungeons"},
	{"Cobalt",350,"Howling Fjord, Zul'Drak, Borean Tundra, Dragonblight, Grizzly Hills, and Crystalsong Forest"},
	{"Rich Cobalte",375,"Howling Fjord, Zul'Drak, Borean Tundra, Dragonblight, Grizzly Hills"},
	{"Saronite",400,"Sholazar Basin, Zul'Drak"},
	{"Obsidium",425,"Mount Hyjal,Vashj'ir"},
	{"Elementium",475,"Twilight Highlands"},
	{"Rich Elementium",500,"Twilight Highlands"},
	{"Pyrite",525,"Twilight Highlands"},
	{"Ghost Iron",525,"The Jade Forest, Valley of the Four Winds, Townlong Steppes, Kun-Lai Summit"},
	{"Rich Ghost Iron",550,"Valley of the Four Winds"},
	{"Trillium",600,"Kun-Lai Summit, Townlong Steppes, Dreaded Wastes, Vale of Eternal Blossoms"},
}

---------------------------
-- herbalism
---------------------------
Glance.Data.Herbalism = {
	{"Peacebloom",1,"Darkshore, Dun Morogh, Durotar, Elwynn Forest, Loch Modan, Mulgore, Silverpine Forest, Teldrassil, The Barrens, Tirisfal Glades, Westfall"},
	{"Silverleaf",1,"Darkshore, Dun Morogh, Durotar, Elwynn Forest, Loch Modan, Mulgore, Silverpine Forest, Teldrassil, The Barrens, Thunder Bluff, Tirisfal Glades, Westfall"},
	{"Earthroot",15,"Darkshore, Dun Morogh, Durotar, Elwynn Forest, Loch Modan, Mulgore, Redridge Mountains, Silverpine Forest, Teldrassil, The Barrens, Tirisfal Glades, Westfall"},
	{"Mageroyal",50,"Ashenvale, Darkshore, Durotar, Duskwood, Hillsbrad Foothills, Loch Modan, Redridge Mountains, Silverpine Forest, Stonetalon Mountains, Teldrassil, The Barrens, Westfall, Wetlands"},
	{"Briarthorn",70,"Ashenvale, Darkshore, Duskwood, Hillsbrad Foothills, Loch Modan, Redridge Mountains, Silverpine Forest, The Barrens, Westfall, Wetlands"},
	{"Stranglekelp",85,"Alterac Mountains, Arathi Highlands, Ashenvale, Azshara, Darkshore, Desolace, Dustwallow Marsh, Feralas, Hillsbrad Foothills, Silverpine Forest, Stranglethorn Vale, Swamp of Sorrows, Tanaris, The Barrens, The Hinterlands, Westfall, Wetlands"},
	{"Bruiseweed",100,"Alterac Mountains, Arathi Highlands, Ashenvale, Darkshore, Desolace, Hillsbrad Foothills, Loch Modan, Redridge Mountains, Silverpine Forest, Stonetalon Mountains, The Barrens, Thousand Needles, Westfall, Wetlands"},
	{"Wild Steelbloom",115,"Alterac Mountains, Arathi Highlands, Ashenvale, Badlands, Desolace, Duskwood, Hillsbrad Foothills, Stonetalon Mountains, Stranglethorn Vale, The Barrens, Thousand Needles, Wetlands"},
	{"Grave Moss",120,"Alterac Mountains, Arathi Highlands, Desolace, Duskwood, The Barrens, Wetlands"},
	{"Kingsblood",125,"Alterac Mountains, Arathi Highlands, Ashenvale, Badlands, Desolace, Duskwood, Dustwallow Marsh, Hillsbrad Foothills, Stonetalon Mountains, Stranglethorn Vale, Swamp of Sorrows, The Barrens, Thousand Needles, Wetlands"},
	{"Liferoot",150,"Alterac Mountains, Arathi Highlands, Ashenvale, Desolace, Dustwallow Marsh, Feralas, Hillsbrad Foothills, Silverpine Forest, Stranglethorn Vale, The Hinterlands, Wetlands"},
	{"Fadeleaf",160,"Alterac Mountains, Arathi Highlands, Badlands, Dustwallow Marsh, Stranglethorn Vale, Swamp of Sorrows, The Hinterlands"},
	{"Goldthorn",170,"Alterac Mountains, Arathi Highlands, Azshara, Badlands, Blasted Lands, Dustwallow Marsh, Feralas, Stranglethorn Vale, Swamp of Sorrows, The Hinterlands"},
	{"Khadgar's Whisker",185,"Alterac Mountains, Arathi Highlands, Azshara, Badlands, Dustwallow Marsh, Feralas, Hillsbrad Foothills, Stranglethorn Vale, Swamp of Sorrows, The Hinterlands"},
	{"Wintersbite",195,"Alterac Mountains"},
	{"Firebloom",205,"Badlands, Blasted Lands, Searing Gorge, Tanaris"},
	{"Purple Lotus",210,"Ashenvale, Azshara, Badlands, Feralas, Stranglethorn Vale, Tanaris, The Hinterlands"},
	{"Arthas' Tears",220,"Eastern Plaguelands, Felwood, Western Plaguelands"},
	{"Sungrass",230,"Azshara, Blasted Lands, Burning Steppes, Eastern Plaguelands, Felwood, Feralas, Silithus, The Hinterlands, Un'Goro Crater, Western Plaguelands"},
	{"Blindweed",235,"Swamp of Sorrows, Un'Goro Crater"},
	{"Ghost Mushroom",245,"The Hinterlands"},
	{"Gromsblood",250,"Ashenvale, Blasted Lands, Desolace, Felwood"},
	{"Golden Sansam",260,"Azshara, Burning Steppes, Eastern Plaguelands, Felwood, Feralas, Silithus, The Hinterlands, Un'Goro Crater"},
	{"Dreamfoil",270,"Azshara, Burning Steppes, Eastern Plaguelands, Felwood, Silithus, Un'Goro Crater, Western Plaguelands"},
	{"Mountain Silversage",280,"Azshara, Burning Steppes, Eastern Plaguelands, Felwood, Silithus, Un'Goro Crater, Western Plaguelands, Winterspring"},
	{"Plaguebloom",285,"Eastern Plaguelands, Felwood, Western Plaguelands"},
	{"Icecap",290,"Winterspring"},
	{"Black Lotus",300,"Burning Steppes, Eastern Plaguelands, Silithus, Winterspring"},
	{"Felweed",300,"Hellfire Peninsula, Zangarmarsh, Nagrand, Blade's Edge Mountains, Terokkar Forest, Shadowmoon Valley, Netherstorm"},
	{"Dreaming Glory",315,"Hellfire Peninsula, Zangarmarsh, Nagrand, Blade's Edge Mountains, Terokkar Forest, Shadowmoon Valley, Netherstorm"},
	{"Terocone",325,"Terokkar Forest, Shadowmoon Valley"},
	{"Ragveil",325,"Zangarmarsh"},
	{"Flame Cap",335,"Zangarmarsh"},
	{"Ancient Lichen",340,"Dungeons Only"},
	{"Netherbloom",350,"Netherstorm"},
	{"Nightmare Vine",365,"Shadowmoon Valley"},
	{"Mana Thistle",375,"Nagrand, Blade's Edge Mountains, Terokkar Forest, Shadowmoon Valley, Netherstorm"},
	{"Tiger Lily",400,"Borean Tundra, Grizzly Hills, Howling Fjord, Sholazar Basin, Zul'Drak"},
	{"Cinderbloom",425,"Mount Hyjal"},
	{"Adder's Tongue",430,"Sholazar Basin"},
	{"Azshara's Veil",450,"Mount Hyjal"},
	{"Heartblossom",475,"Deepholm"},
	{"Whiptail",500,"Uldum"},
	{"Green Tea Leaf",500,"Jade Forest, Valley of the Four Winds, Krasarang Wilds, Kun-Lai Summit"},
	{"Rain Poppy",525,"Jade Forest"},
	{"Silkweed",545,"Valley of the Four Winds"},
	{"Golden Lotus",550,"The Jade Forest, Valley of the Four Winds, Kun-Lai Summit"},
	{"Snow Lily",575,"Kun-Lai Summit"},
	{"Fool's Cap",600,"Dread Wastes, Townlong Steppes, The Jade Forest"},
}

---------------------------
-- load on demand
---------------------------
if gv.loaded then
	gf.Enable("Professions")
end